#include <stdio.h>
#include <Xm/Xm.h>
#include <X11/xpm.h>
#include <X11/cursorfont.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>

#include "HTML2.h"


Cursor gotocursor;
static XtWorkProcId work_id;

static Widget toplevel, help;
static XtAppContext app_context;
static XtInputId ipid;
static char *hf;
static int npages;
static int offset;
static int nitems;
static int current_page;
static char *page;
static int pagelen;

static void activate(Widget w, XtPointer call_data, XfwfFTextCallbackStruct * cd);

typedef struct {
    char *name;
    long length;
    long offset;
} Toc;

Toc *toc;

static String fallback_resources[] =
{
    "Help.geometry: 375x400",
    "Help*background:	#ffffd6",

    /* Style sheet */
    /* "*textbackground: transparent", */
    "*style:\
*id: !ID\\n\
*language: !LANG\\n\
*target: !ID\\n\
HTML.leftindent: 4.0\\n\
HTML.rightindent: 4.0\\n\
HTML.justify: left\\n\
*H1.size: +2\\n\
*H1.bold: true\\n\
*H1.justify: center\\n\
*H1.rulebefore: 1.0\\n\
*H1.ruleafter: 1.0\\n\
*H1.prebreak: 2.0\\n\
*H1.postbreak: 1.0\\n\
*H1.noindent: false\\n\
*H2.size: +1\\n\
*H2.bold: true\\n\
*H2.justify: left\\n\
*H2.rulebefore: 0.3\\n\
*H2.prebreak: 1.0\\n\
*H2.postbreak: 1.0\\n\
*H2.leftindent: -3.0\\n\
*H2.parindent: 0.0\\n\
*H2.noindent: false\\n\
*H3.size: +1\\n\
*H3.justify: left\\n\
*H3.prebreak: 1.0\\n\
*H3.postbreak: 1.0\\n\
*H3.leftindent: -3.0\\n\
*H3.parindent: 0.0\\n\
*H3.noindent: false\\n\
*H4.bold: true\\n\
*H4.justify: left\\n\
*H4.prebreak: 1.0\\n\
*H4.postbreak: 0.5\\n\
*H4.parindent: 0.0\\n\
*H4.noindent: false\\n\
*H5.bold: true\\n\
*H5.prebreak: 1.0\\n\
*H5.parindent: 0.0\\n\
*H6.prebreak: 1.0\\n\
*H6.parindent: 0.0\\n\
*P.parindent: 2.0\\n\
*P.postbreak: 0.0\\n\
*U.underscore: 1\\n\
*S.strikeout: true\\n\
*TT.family: tt\\n\
*B.bold: true\\n\
*I.slant: true\\n\
*BIG.size: 1\\n\
*SMALL.size: -1\\n\
*EM.emphasis: 1\\n\
*STRONG.emphasis: 2\\n\
*CODE.family: alt\\n\
*CODE.size: -1\\n\
*SAMP.family: tt\\n\
*KBD.family: tt\\n\
*KDB.underscore: 1\\n\
*VAR.slant: true\\n\
*CITE.slant: true\\n\
*BR.empty: true\\n\
*BR.prebreak: 0.0\\n\
*BR.flush: !CLEAN\\n\
*BR.noindent: True\\n\
*WBR.empty: True\\n\
*WBR.insertbefore: &sbsp;\\n\
*A.textcolor: blue\\n\
*A.underscore: 0\\n\
*A.anchor: !HREF\\n\
*A.target: !NAME\\n\
*IMG.empty: true\\n\
*IMG.inline: !SRC\\n\
*IMG.valign: !ALIGN\\n\
*IMG.track: !ALIGN\\n\
*IMG.ismap: @ifmatch(!ISMAP, \"ISMAP\", true, false)\\n\
*IMG.width: !WIDTH\\n\
*IMG.height: !HEIGHT\\n\
*HR.empty: true\\n\
*HR.prebreak: 0.5\\n\
*HR.rulebefore: 0.0\\n\
*HR.postbreak: 0.0\\n\
*PRE.prebreak: 0.5\\n\
*PRE.postbreak: 0.5\\n\
*PRE.family: tt\\n\
*PRE.justify: left\\n\
*PRE.width: !WIDTH\\n\
*PRE.obeyspaces: true\\n\
*DL.prebreak: 1.0\\n\
*DL.postbreak: 1.0\\n\
*DL.leftindent: 2.0\\n\
*DT.prebreak: 0.5\\n\
*DT.parindent: -2.0\\n\
*DT.bold: true\\n\
*DT.insertafter:  \\n\
*DD.postbreak: 0.5\\n\
*OL.prebreak: 1.0\\n\
*OL.postbreak: 1.0\\n\
*OL.leftindent: 2.0\\n\
*UL.prebreak: 1.0\\n\
*UL.postbreak: 1.0\\n\
*UL.leftindent: 2.0\\n\
*LI.prebreak: 0.5\\n\
*LI.postbreak: 0.5\\n\
*OL.LI.label: 1\\n\
*OL*OL.LI.label: A\\n\
*OL*OL*OL.LI.label: I\\n\
*LI.label: bullet",

    NULL,
};

struct header {
    char header[64];
    long npages;
    long nitems;
    long offset;
};


static String txt = "\
<H1>Help File Viewer</H1>\n\
\n\
<P>Call this program with a <B>file name</B> as argument.\n\
\n\
\n\
";

static char *get_img(char *url, int *length)
{
    int i;

    for (i = npages; i < nitems; i++) {
        if (strncmp(url, toc[i].name + 1, (int) *toc[i].name) == 0) {
            *length = toc[i].length;
            return hf + toc[i].offset;
        }
    }
    *length = 0;
    return NULL;
}

static void resolve(Widget w, XtPointer call_data, XfwfResolveRec * cd)
{
    int i, b;
    Pixel fg, bg;
    Pixmap pmap;
    char *p;
    XpmAttributes attr;
    Display *dpy = XtDisplayOfObject(toplevel);
    Screen *scr = XtScreenOfObject(toplevel);
    Window rootWindow = XRootWindowOfScreen(scr);

    p = get_img(cd->url, &pagelen);
    attr.visual = DefaultVisual(dpy, DefaultScreen(dpy));
    attr.colormap = DefaultColormap(dpy, DefaultScreen(dpy));
    attr.depth = DefaultDepthOfScreen(scr);
    attr.exactColors = False;
    attr.closeness = 40000;

    attr.valuemask = XpmExactColors | XpmCloseness;

    if (XpmCreatePixmapFromBuffer(XtDisplay(toplevel),
             XtWindow(toplevel), p,
             &pmap, NULL,
             &attr) != XpmSuccess)
        fprintf(stderr, "Error reading help pixmap %s!\n", cd->url);

    XtVaSetValues(cd->widget,
        XtNwidth, attr.width,
        XtNheight, attr.height,
        XtNbackgroundPixmap, pmap,
        NULL);
}

static int init_help()
{
    struct header *p;
    char *cp;
    int i;
    long loff = 0;

    p = (struct header *) hf;

    if (strncmp("hlp07", hf, 5)) {
        fprintf(stderr,"Invalid Help File!\nNo Help available.");
        return 0;
    }

    npages = ntohl(p->npages);
    nitems = ntohl(p->nitems);
    offset = ntohl(p->offset);

    toc = (Toc *) calloc(nitems, sizeof(Toc));
    cp = hf + sizeof(struct header);

    for (i = 0; i < nitems; i++) {
        toc[i].name = cp;
        toc[i].offset = loff + offset;;
        toc[i].length = ntohl(*(long *) ((cp + *cp) + 1L));
        loff += toc[i].length;
        cp += *cp + sizeof(char) + sizeof(long);
    }
    return 1;
}


static char *get_url(char *url, int *length)
{
    int i;

    for (i = 0; i < npages; i++) {
	if (strncmp(url, toc[i].name + 1, (int) *toc[i].name) == 0) {
	    fprintf(stderr, "Found %s\n", toc[i].name + 1);
	    *length = toc[i].length;
	    return hf + toc[i].offset;
	}
    }
    XBell(XtDisplay(toplevel), 0);
    return NULL;
}

static char *get_page(char *url, int *length)
{
    int i;

    for (i = 0; i < npages; i++) {
        if (strncmp(url, toc[i].name + 1, (int) *toc[i].name) == 0) {
            current_page = i;
            *length = toc[i].length;
            return hf + toc[i].offset;
        }
    }
    return NULL;
}


static int new_page()
{
    if (help) {
    XtUnmanageChild(help);
    XtRemoveAllCallbacks(help,XtNactivate);
    XtRemoveAllCallbacks(help,XtNresolveURL);

//FIXME for now we are leaking memory here.
//I do not understand why we get a core when help is destroyed.
//    XtDestroyWidget(help);
    }

    help = XtVaCreateManagedWidget("Help", xfwfHTML2WidgetClass, toplevel,
                                   XtNactiveCursor, gotocursor,
                                   NULL);
    XtAddCallback(help, XtNactivate, (XtCallbackProc) activate, NULL);
    XtAddCallback(help, XtNresolveURL, (XtCallbackProc) resolve, NULL);
    XfwfAddText(help, page, pagelen);
    XfwfAddText(help, NULL, 0);


    return True;
}


static void activate(Widget w, XtPointer call_data, XfwfFTextCallbackStruct * cd)
{
    char *p;
    int len;

    XfwfSSGMLData *pd = cd->data;

    page = get_page(pd->url, &pagelen);

    if (page) work_id = XtAppAddWorkProc(app_context, (XtWorkProc)new_page, NULL);
}

void main(int argc, String * argv)
{
    int fd;
    struct stat statbuf;
    int len, size;
    char *p;

    toplevel = XtVaAppInitialize(&app_context, "Help", NULL, 0,
				 &argc, argv, fallback_resources, NULL);

    gotocursor = XCreateFontCursor(XtDisplay(toplevel), XC_hand2);

    help = XtVaCreateManagedWidget("Help", xfwfHTML2WidgetClass, toplevel,
				   XtNactiveCursor, gotocursor,
				   NULL);

    XtAddCallback(help, XtNactivate, activate, NULL);
    XtAddCallback(help, XtNresolveURL, resolve, NULL);
    XtRealizeWidget(toplevel);
    if (argc < 2) {
	XfwfAddText(help, txt, strlen(txt));
	XfwfAddText(help, NULL, 0);
    } else {
	if ((fd = open(argv[1], O_RDONLY)) == -1) {
	    perror(argv[1]);
	    exit(1);
	}
	fstat(fd, &statbuf);
	size = statbuf.st_size;
	hf = mmap(0, size, PROT_READ, MAP_SHARED, fd, 0);

	init_help();
	p = get_url("index.html", &len);

	XfwfAddText(help, p, len);
	XfwfAddText(help, NULL, 0);
    }
    XtAppMainLoop(app_context);
}
