/*
 *    Copyright  1996, 1997, 1998, 1999, 2000 by Remco Treffkorn
 *    Distributed under the terms of the Q Public License. Please see
 *    the included file LICENSE.
 */
#include "config.h"
#include <X11/Xos.h>
#include "xmap.h"
#include "mode.h"
#include "debug.h"

String cheapcolor = "*background: #c3c3c3";

String fallback_resources[] =
{
    "*background: #bda69c",	// This must be first. Will be overwritten by
				// cheapcolor when needed.
    "*foreground: black",
    "*highlightColor: black",
    "*showSeparator: On",
    "*draw_w.background: grey",
    "*menuBar*foreground: black",
    "*menuBar*shadowThickness: 1",
    "*menuBar.shadowThickness: 0",
    ".xmap.width:    600",
    ".xmap.height:   400",
    "*menuBar.file.labelString: File",
    "*menuBar.file.mnemonic: F",
    "*menuBar.edit.labelString: Edit",
    "*menuBar.edit.mnemonic: E",
    "*menuBar.search.labelString: Search",
    "*menuBar.search.mnemonic: S",
    "*menuBar.view.labelString: View",
    "*menuBar.view.mnemonic: V",
    "*menuBar.route.labelString: Route",
    "*menuBar.route.mnemonic: R",
    "*menuBar.options.labelString: Options",
    "*menuBar.options.mnemonic: O",
    "*menuBar.gps.labelString: Gps",
    "*menuBar.gps.mnemonic: G",
    "*menuBar.help.labelString: Help",
    "*menuBar.help.mnemonic: H",
    "*statusbar*foreground: black",

    "*mapdialog*foreground: black",
    "*mapdialog*highlightThickness: 0",
    "*mapdialog*XmToggleButton.marginHeight: 6",
    "*mapdialog*XmToggleButton.marginWidth: 4",
    "*mapdialog*XmToggleButton.selectColor: green",
    "*mapdialog*XmToggleButton.shadowThickness: 0",
    "*mapdialog*XmForm.shadowThickness: 0",

    "*mapdialog*XmFrame.shadowType: SHADOW_ETCHED_IN",
    "*mapdialog*XmFrame.shadowThickness: 2",


    "*mapdialog*toggleButton_15.labelString: Major",
    "*mapdialog*toggleButton_16.labelString: Minor",
    "*mapdialog*toggleButton_17.labelString: Names",
    "*mapdialog*toggleButton_18.labelString: Route Symbols",

    "*mapdialog*toggleButton_7.labelString: Major",
    "*mapdialog*toggleButton_8.labelString: Minor",
    "*mapdialog*toggleButton_9.labelString: Names",

    "*mapdialog*toggleButton_1.labelString: Major",
    "*mapdialog*toggleButton_2.labelString: Minor",

    "*mapdialog*toggleButton_3.labelString: Railroads",
    "*mapdialog*toggleButton_4.labelString: Bdys/Urbans",
    "*mapdialog*toggleButton_5.labelString: Map Tints",
    "*mapdialog*toggleButton_6.labelString: ZIP Codes",
    "*mapdialog*XmFrame.XmForm.XmLabel.marginTop: 2",
    "*mapdialog*XmFrame.XmForm.XmLabel.marginRight: 2",

    "*selectdialog*highlightThickness: 0",
//    "*selectdialog*time*sensitive: False",

#if XmVersion >= 2000
    "*indicatorOn: INDICATOR_CHECK",
//    "*enableToggleVisual: True",
#endif

    "*XmToggleButton.selectColor: green",
    "*XmToggleButtonGadget.selectColor: green",

    "*mw.columnLabels: Nr., Name, Latitude, Longitude, Dist., Bear., Easting, Northing, Zone, Alarm Rad, Description, Action",
    "*mw.columnLabelAlignments: ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_CENTER",
    "*mw.columnAlignments: ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_END, ALIGNMENT_END, ALIGNMENT_CENTER, ALIGNMENT_CENTER, ALIGNMENT_END, ALIGNMENT_END, ALIGNMENT_END, ALIGNMENT_CENTER, ALIGNMENT_END, ALIGNMENT_END",
    "*mw.columnWidths: 3, 16, 12, 13, 7, 5, 11, 11, 7, 10, 38, 38",
    "*mw.columns: 12",
    "*mw.visibleColumns: 5",
    "*mw.visibleRows: 8",
    "*mw.rows: 8",
    "*mw.fixedColumns: 1",
    "*mw.shadowType: SHADOW_ETCHED_IN",
    "*mw.highlightColor: black",
    "*mw.cellHighlightThickness: 1",
    "*mw.gridType: GRID_SHADOW_IN",
    "*mw.cellMarginWidth: 2",
    "*mw.cellMarginHeight: 2",
    "*mw.verticalScrollBarDisplayPolicy: DISPLAY_STATIC",


#ifdef DND
    "*DragInitiatorProtocolStyle: DRAG_PREREGISTER",
    "*DragReceiverProtocolStyle: DRAG_PREREGISTER",
#endif

#if 0
//    "*help.work_area.fr1.Help.background: #ffffd6",
    "*style:\
*BODY.empty: true\\n\
*BODY.tile: \
/* XPM */\\\\n\\\
static char * tmp [] = {\\\\n\\\
/* width height ncolors cpp [x_hot y_hot] */\\\\n\\\
\"8 8 2 1 0 0\",\\\\n\\\
/* colors */\\\\n\\\
\"      c yellow\",\\\\n\\\
\".     c white\",\\\\n\\\
/* pixels */\\\\n\\\
\" ... ...\",\\\\n\\\
\"........\",\\\\n\\\
\"........\",\\\\n\\\
\"........\",\\\\n\\\
\".. ... .\",\\\\n\\\
\"........\",\\\\n\\\
\"........\",\\\\n\\\
\"........\"};\\n\
*id: !ID\\n\
*language: !LANG\\n\
*target: !ID\\n\
HTML.leftindent: 3.0\\n\
HTML.rightindent: 3.0\\n\
HTML.justify: left\\n\
HTML.vmargin: 0.5\\n\
*H1.size: +2\\n\
*H1.bold: true\\n\
*H1.justify: center\\n\
*H1.rulebefore: 0.6\\n\
*H1.ruleafter: 0.6\\n\
*H1.prebreak: 1.0\\n\
*H1.postbreak: 1.0\\n\
*H1.noindent: false\\n\
*H2.size: +1\\n\
*H2.bold: true\\n\
*H2.justify: left\\n\
*H2.rulebefore: 0.3\\n\
*H2.prebreak: 1.0\\n\
*H2.postbreak: 1.0\\n\
*H2.leftindent: -3.0\\n\
*H2.parindent: 0.0\\n\
*H2.noindent: false\\n\
*H3.size: +1\\n\
*H3.justify: left\\n\
*H3.prebreak: 1.0\\n\
*H3.postbreak: 1.0\\n\
*H3.leftindent: -3.0\\n\
*H3.parindent: 0.0\\n\
*H3.noindent: false\\n\
*H4.bold: true\\n\
*H4.justify: left\\n\
*H4.prebreak: 1.0\\n\
*H4.postbreak: 0.5\\n\
*H4.parindent: 0.0\\n\
*H4.noindent: false\\n\
*H5.bold: true\\n\
*H5.prebreak: 1.0\\n\
*H5.parindent: 0.0\\n\
*H6.prebreak: 0.0\\n\
*H6.parindent: -1.0\\n\
*H6.justify: center\\n\
*P.parindent: 1.0\\n\
*P.postbreak: 0.5\\n\
*U.underscore: 1\\n\
*S.strikeout: true\\n\
*TT.family: tt\\n\
*B.bold: true\\n\
*I.slant: true\\n\
*BIG.size: 1\\n\
*SMALL.size: -1\\n\
*EM.emphasis: 1\\n\
*STRONG.emphasis: 2\\n\
*CODE.family: alt\\n\
*CODE.size: -1\\n\
*SAMP.family: tt\\n\
*KBD.family: tt\\n\
*KDB.underscore: 1\\n\
*VAR.slant: true\\n\
*CITE.slant: true\\n\
*BR.empty: true\\n\
*BR.prebreak: 0.0\\n\
*BR.flush: !CLEAN\\n\
*BR.noindent: True\\n\
*WBR.empty: True\\n\
*WBR.insertbefore: &sbsp;\\n\
*A.textcolor: blue\\n\
*A.underscore: 1\\n\
*A.anchor: !HREF\\n\
*A.target: !NAME\\n\
*IMG.empty: true\\n\
*IMG.inline: !SRC\\n\
*IMG.valign: !ALIGN\\n\
*IMG.track: !ALIGN\\n\
*IMG.ismap: @ifmatch(!ISMAP, \"ISMAP\", true, false)\\n\
*IMG.width: !WIDTH\\n\
*IMG.height: !HEIGHT\\n\
*HR.empty: true\\n\
*HR.prebreak: 0.5\\n\
*HR.rulebefore: 0.0\\n\
*HR.postbreak: 0.0\\n\
*PRE.prebreak: 0.5\\n\
*PRE.postbreak: 0.5\\n\
*PRE.family: tt\\n\
*PRE.justify: left\\n\
*PRE.width: !WIDTH\\n\
*PRE.obeyspaces: true\\n\
*DL.prebreak: 1.0\\n\
*DL.postbreak: 1.0\\n\
*DL.leftindent: 2.0\\n\
*DT.prebreak: 0.5\\n\
*DT.parindent: -2.0\\n\
*DT.bold: true\\n\
*DT.insertafter:  \\n\
*DD.postbreak: 0.5\\n\
*OL.prebreak: 1.0\\n\
*OL.postbreak: 1.0\\n\
*OL.leftindent: 2.0\\n\
*UL.prebreak: 1.0\\n\
*UL.postbreak: 1.0\\n\
*UL.leftindent: 2.0\\n\
*LI.prebreak: 0.5\\n\
*LI.postbreak: 0.5\\n\
*OL.LI.label: 1\\n\
*OL*OL.LI.label: A\\n\
*OL*OL*OL.LI.label: I\\n\
*LI.label: bullet",
#else
    /* Style sheet */
    "*style:\
*BODY.empty: true\\n\
*BODY.tile: \
/* XPM */\\\\n\\\
static char * tmp [] = {\\\\n\\\
/* width height ncolors cpp [x_hot y_hot] */\\\\n\\\
\"8 8 2 1 0 0\",\\\\n\\\
/* colors */\\\\n\\\
\"      c yellow\",\\\\n\\\
\".     c white\",\\\\n\\\
/* pixels */\\\\n\\\
\" ... ...\",\\\\n\\\
\"........\",\\\\n\\\
\"........\",\\\\n\\\
\"........\",\\\\n\\\
\".. ... .\",\\\\n\\\
\"........\",\\\\n\\\
\"........\",\\\\n\\\
\"........\"};\\n\
*id: !ID\\n\
*language: !LANG\\n\
*target: !ID\\n\
HTML.leftindent: 2.0\\n\
HTML.rightindent: 2.0\\n\
HTML.justify: left\\n\
*H1.size: +2\\n\
*H1.bold: true\\n\
*H1.justify: center\\n\
*H1.rulebefore: 0.5\\n\
*H1.ruleafter: 0.5\\n\
*H1.prebreak: 1.0\\n\
*H1.postbreak: 1.0\\n\
*H1.noindent: false\\n\
*H2.size: +1\\n\
*H2.bold: true\\n\
*H2.justify: left\\n\
*H2.rulebefore: 0.3\\n\
*H2.prebreak: 1.0\\n\
*H2.postbreak: 1.0\\n\
*H2.leftindent: -2.0\\n\
*H2.parindent: 0.0\\n\
*H2.noindent: false\\n\
*H3.size: +1\\n\
*H3.justify: left\\n\
*H3.prebreak: 1.0\\n\
*H3.postbreak: 1.0\\n\
*H3.leftindent: -2.0\\n\
*H3.parindent: 0.0\\n\
*H3.noindent: false\\n\
*H4.bold: true\\n\
*H4.justify: left\\n\
*H4.prebreak: 1.0\\n\
*H4.postbreak: 0.5\\n\
*H4.parindent: 0.0\\n\
*H4.noindent: false\\n\
*H5.bold: true\\n\
*H5.prebreak: 1.0\\n\
*H5.parindent: 0.0\\n\
*H6.prebreak: 1.0\\n\
*H6.parindent: 0.0\\n\
*P.parindent: 2.0\\n\
*P.prebreak: 0.5\\n\
*P.postbreak: 0.0\\n\
*U.underscore: 1\\n\
*S.strikeout: true\\n\
*TT.family: tt\\n\
*B.bold: true\\n\
*I.slant: true\\n\
*BIG.size: 1\\n\
*SMALL.size: -1\\n\
*EM.emphasis: 1\\n\
*STRONG.emphasis: 2\\n\
*CODE.family: alt\\n\
*CODE.size: -1\\n\
*SAMP.family: tt\\n\
*KBD.family: tt\\n\
*KDB.underscore: 1\\n\
*VAR.slant: true\\n\
*CITE.slant: true\\n\
*BR.empty: true\\n\
*BR.prebreak: 0.0\\n\
*BR.flush: !CLEAN\\n\
*BR.noindent: True\\n\
*WBR.empty: True\\n\
*WBR.insertbefore: &sbsp;\\n\
*A.textcolor: blue\\n\
*A.underscore: 0\\n\
*A.anchor: !HREF\\n\
*A.target: !NAME\\n\
*IMG.empty: true\\n\
*IMG.inline: !SRC\\n\
*IMG.valign: !ALIGN\\n\
*IMG.track: !ALIGN\\n\
*IMG.ismap: @ifmatch(!ISMAP, \"ISMAP\", true, false)\\n\
*IMG.width: !WIDTH\\n\
*IMG.height: !HEIGHT\\n\
*HR.empty: true\\n\
*HR.prebreak: 0.5\\n\
*HR.rulebefore: 0.0\\n\
*HR.postbreak: 0.0\\n\
*PRE.prebreak: 0.5\\n\
*PRE.postbreak: 0.5\\n\
*PRE.family: tt\\n\
*PRE.justify: left\\n\
*PRE.width: !WIDTH\\n\
*PRE.obeyspaces: true\\n\
*DL.prebreak: 1.0\\n\
*DL.postbreak: 1.0\\n\
*DL.leftindent: 2.0\\n\
*DT.prebreak: 0.5\\n\
*DT.parindent: -2.0\\n\
*DT.bold: true\\n\
*DT.insertafter:  \\n\
*DD.postbreak: 0.5\\n\
*OL.prebreak: 1.0\\n\
*OL.postbreak: 1.0\\n\
*OL.leftindent: 2.0\\n\
*UL.prebreak: 1.0\\n\
*UL.postbreak: 1.0\\n\
*UL.leftindent: 2.0\\n\
*LI.prebreak: 0.5\\n\
*LI.postbreak: 0.5\\n\
*OL.LI.label: 1\\n\
*OL*OL.LI.label: A\\n\
*OL*OL*OL.LI.label: I\\n\
*LI.label: bullet",
#endif

    NULL,
};

